#ifndef PROCESSOR_HPP_
#define PROCESSOR_HPP_
#include "test2visitor.h"

class Processor : public Visitor
{
	public:
		virtual ~Processor() {}
		virtual void visit_grammar_production(
			const grammar_production* pgrammar_production
			);

		virtual void visit_grammar_grammar_production(
			const grammar_grammar_production* pgrammar_grammar_production
			);

		virtual void visit_grammar_grammar_COMMENT(
			const grammar_grammar_COMMENT* pgrammar_grammar_COMMENT
			);

		virtual void visit_production(
			const production* pproduction
			);

		virtual void visit_lhs(
			const lhs* plhs
			);

		virtual void visit_expression_base(
			const expression_base* pexpression_base
			);

		virtual void visit_expression_base_OPT(
			const expression_base_OPT* pexpression_base_OPT
			);

		virtual void visit_expression_base_STAR(
			const expression_base_STAR* pexpression_base_STAR
			);

		virtual void visit_expression_base_PLUS(
			const expression_base_PLUS* pexpression_base_PLUS
			);

		virtual void visit_expression_COMMENT(
			const expression_COMMENT* pexpression_COMMENT
			);

		virtual void visit_base_LITERAL(
			const base_LITERAL* pbase_LITERAL
			);

		virtual void visit_base_IDENT(
			const base_IDENT* pbase_IDENT
			);

		virtual void visit_base_LPAREN_expressionList_RPAREN(
			const base_LPAREN_expressionList_RPAREN* pbase_LPAREN_expressionList_RPAREN
			);

		virtual void visit_base_LPAREN_alternation_RPAREN(
			const base_LPAREN_alternation_RPAREN* pbase_LPAREN_alternation_RPAREN
			);

		virtual void visit_alternation_expression_OR_expression(
			const alternation_expression_OR_expression* palternation_expression_OR_expression
			);

		virtual void visit_alternation_alternation_OR_expression(
			const alternation_alternation_OR_expression* palternation_alternation_OR_expression
			);

};

#endif
